SystemOrganization addCategory: #ConfigurationOfChalten!

Object subclass: #ConfigurationOfChalten
	instanceVariableNames: 'project'
	classVariableNames: 'LastVersionLoad'
	poolDictionaries: ''
	category: 'ConfigurationOfChalten'!

!ConfigurationOfChalten class methodsFor: 'development support' stamp: 'MaximilianoTaborda 5/29/2013 19:45'!
DevelopmentSupport

"See the methods in the 'development support' category on the class-side of MetacelloBaseConfiguration. Decide what development support methods you would like to use and copy them the the class-side of your configuration."
	<apiDocumentation>
! !

!ConfigurationOfChalten class methodsFor: 'private' stamp: 'MaximilianoTaborda 5/29/2013 19:45'!
baseConfigurationClassIfAbsent: aBlock

	^Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			self ensureMetacelloBaseConfiguration.
			Smalltalk at: #MetacelloBaseConfiguration ifAbsent: aBlock ].
! !

!ConfigurationOfChalten class methodsFor: 'private' stamp: 'MaximilianoTaborda 5/29/2013 19:45'!
ensureMetacello

	(self baseConfigurationClassIfAbsent: []) ensureMetacello! !

!ConfigurationOfChalten class methodsFor: 'private' stamp: 'MaximilianoTaborda 5/29/2013 19:45'!
ensureMetacelloBaseConfiguration

	Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			| repository version |
			repository := MCHttpRepository location: 'http://seaside.gemstone.com/ss/metacello' user: '' password: ''.
			repository
				versionReaderForFileNamed: 'Metacello-Base-DaleHenrichs.2.mcz'
				do: [ :reader | 
					version := reader version.
					version load.
					version workingCopy repositoryGroup addRepository: repository ] ]! !

!ConfigurationOfChalten class methodsFor: 'metacello tool support' stamp: 'MaximilianoTaborda 5/29/2013 19:45'!
isMetacelloConfig
	"Answer true and the Metacello tools will operate on you"
	
	^true! !

!ConfigurationOfChalten class methodsFor: 'loading' stamp: 'MaximilianoTaborda 5/29/2013 19:45'!
load
	"Load the #stable version defined for this platform. The #stable version is the version that is recommended to be used on this platform."

	"self load"

	<apiDocumentation>
	^(self project version: #stable) load! !

!ConfigurationOfChalten class methodsFor: 'loading' stamp: 'MaximilianoTaborda 5/29/2013 19:45'!
loadBleedingEdge
	"Load the latest versions of the mcz files defined for this project. It is not likely that the #bleedingEdge has been tested."

	"self loadBleedingEdge"

	<apiDocumentation>
	^(self project version: #bleedingEdge) load! !

!ConfigurationOfChalten class methodsFor: 'loading' stamp: 'MaximilianoTaborda 5/29/2013 19:45'!
loadDevelopment
	"Load the #development version defined for this platform. The #development version will change over time and is not expected to be stable."

	"self loadDevelopment"

	<apiDocumentation>
	^(self project version: #development) load! !

!ConfigurationOfChalten class methodsFor: 'accessing' stamp: 'MaximilianoTaborda 5/29/2013 19:45'!
project

	^self new project! !

!ConfigurationOfChalten class methodsFor: 'development support' stamp: 'MaximilianoTaborda 5/29/2013 19:45'!
validate
	"Check the configuration for Errors, Critical Warnings, and Warnings (see class comment for MetacelloMCVersionValidator for more information). 
	Errors identify specification issues that will result in unexpected behaviour when you load the configuration. 
	Critical Warnings identify specification issues that may result in unexpected behavior when you load the configuration.
	Warnings identify specification issues that are technically correct, but are worth take a look at."

	"self validate"

	<apiDocumentation>
	self ensureMetacello.
	^ ((Smalltalk at: #MetacelloToolBox) validateConfiguration: self debug: #() recurse: false) explore! !

!ConfigurationOfChalten methodsFor: 'baselines' stamp: 'MaximilianoTaborda 5/30/2013 00:23'!
baseline300: spec
	<version: '3.0.0-baseline'>
	spec
		for: #common
		do: [ 
			spec blessing: #baseline.
			spec description: '- Chalten published to SmalltalkHub'.
			spec repository: 'http://smalltalkhub.com/mc/maxi/Chalten/main'.
			spec
				project: 'Aconcagua'
				with: [ 
					spec
						className: 'ConfigurationOfAconcagua';
						versionString: #stable;
						loads: #('Core');
						repository: 'http://smalltalkhub.com/mc/maxi/Aconcagua/main' ].
			spec
				package: 'Chalten-TimeModel-Core' with: [ spec requires: 'Aconcagua' ];
				package: 'Chalten-TimeModel-Tests' with: [ spec requires: 'Chalten-TimeModel-Core' ];
				package: 'Chalten-ChristianTimeModel-Core';
				package: 'Chalten-ChristianTimeModel-Tests' with: [ spec requires: 'Chalten-ChristianTimeModel-Core' ];
				package: 'Chalten-GregorianTimeModel-Core';
				package: 'Chalten-GregorianTimeModel-Tests' with: [ spec requires: 'Chalten-GregorianTimeModel-Core' ];
				package: 'Chalten-JulianTimeModel-Core';
				package: 'Chalten-JulianTimeModel-Tests' with: [ spec requires: 'Chalten-JulianTimeModel-Core' ];
				package: 'Chalten-HebrewTimeModel-Core';
				package: 'Chalten-HebrewTimeModel-Tests' with: [ spec requires: 'Chalten-HebrewTimeModel-Core' ];
				package: 'Chalten-IslamicTimeModel-Core';
				package: 'Chalten-IslamicTimeModel-Tests' with: [ spec requires: 'Chalten-IslamicTimeModel-Core' ];
				package: 'Chalten-TimeLineFilterModel-Core';
				package: 'Chalten-TimeLineFilterModel-Tests' with: [ spec requires: 'Chalten-TimeLineFilterModel-Core' ];
				package: 'Chalten-TimeZoneModel-Core';
				package: 'Chalten-TimeZoneModel-Tests' with: [ spec requires: 'Chalten-TimeZoneModel-Core' ].
			spec
				group: 'default' with: #('Core' 'Tests');
				group: 'Core'
					with:
						#('Chalten-TimeModel-Core' 'Chalten-ChristianTimeModel-Core' 'Chalten-GregorianTimeModel-Core' 'Chalten-JulianTimeModel-Core' 'Chalten-HebrewTimeModel-Core' 'Chalten-IslamicTimeModel-Core' 'Chalten-TimeLineFilterModel-Core' 'Chalten-TimeZoneModel-Core');
				group: 'Tests'
					with:
						#('Chalten-TimeModel-Tests' 'Chalten-ChristianTimeModel-Tests' 'Chalten-GregorianTimeModel-Tests' 'Chalten-JulianTimeModel-Tests' 'Chalten-HebrewTimeModel-Tests' 'Chalten-IslamicTimeModel-Tests' 'Chalten-TimeLineFilterModel-Tests' 'Chalten-TimeZoneModel-Tests');
				group: 'Gregorian-Core'
					with:
						#('Chalten-TimeModel-Core' 'Chalten-ChristianTimeModel-Core' 'Chalten-GregorianTimeModel-Core' 'Chalten-TimeLineFilterModel-Core' 'Chalten-TimeZoneModel-Core');
				group: 'Gregorian-Tests'
					with:
						#('Chalten-TimeModel-Tests' 'Chalten-ChristianTimeModel-Tests' 'Chalten-GregorianTimeModel-Tests' 'Chalten-TimeLineFilterModel-Tests' 'Chalten-TimeZoneModel-Tests') ]! !

!ConfigurationOfChalten methodsFor: 'symbolic versions' stamp: 'MaximilianoTaborda 5/29/2013 20:38'!
bleedingEdge: spec
	<symbolicVersion: #'bleedingEdge'>

	spec for: #'common' version: #'notDefined'! !

!ConfigurationOfChalten methodsFor: 'accessing' stamp: 'MaximilianoTaborda 5/29/2013 19:45'!
customProjectAttributes
	 "Edit to return a collection of any custom attributes e.g. for conditional loading: Array with: #'Condition1' with: #'Condition2.
	For more information see: http://code.google.com/p/metacello/wiki/CustomProjectAttrributes"

	^ #().! !

!ConfigurationOfChalten methodsFor: 'symbolic versions' stamp: 'MaximilianoTaborda 5/29/2013 20:38'!
development: spec
	<symbolicVersion: #'development'>

	spec for: #'common' version: #'notDefined'! !

!ConfigurationOfChalten methodsFor: 'accessing' stamp: 'MaximilianoTaborda 5/29/2013 19:45'!
project

	^ project ifNil: [ | constructor |
		"Bootstrap Metacello if it is not already loaded"
		(self class baseConfigurationClassIfAbsent: []) ensureMetacello.
		"Construct Metacello project"
		project := MetacelloMCProject new projectAttributes: self customProjectAttributes. 
		constructor := (Smalltalk at: #MetacelloVersionConstructor) on: self project: project.
		project loadType: #linear. "change to #atomic if desired"
		project ]! !

!ConfigurationOfChalten methodsFor: 'symbolic versions' stamp: 'MaximilianoTaborda 5/29/2013 20:38'!
stable: spec
	<symbolicVersion: #'stable'>

	spec for: #'common' version: '3.0.0'! !

!ConfigurationOfChalten methodsFor: 'versions' stamp: 'MaximilianoTaborda 5/29/2013 20:46'!
version300: spec
	<version: '3.0.0' imports: #('3.0.0-baseline')>
	spec
		for: #common
		do: [ 
			spec blessing: #release.
			spec description: '3.0.0 final'.
			spec author: 'MaximilianoTaborda'.
			spec
				package: 'Chalten-TimeModel-Core' with: 'Chalten-TimeModel-Core-MaximilianoTaborda.3.0.0';
				package: 'Chalten-TimeModel-Tests' with: 'Chalten-TimeModel-Tests-MaximilianoTaborda.3.0.0';
				package: 'Chalten-ChristianTimeModel-Core' with: 'Chalten-ChristianTimeModel-Core-MaximilianoTaborda.3.0.0';
				package: 'Chalten-ChristianTimeModel-Tests' with: 'Chalten-ChristianTimeModel-Tests-MaximilianoTaborda.3.0.0';
				package: 'Chalten-GregorianTimeModel-Core' with: 'Chalten-GregorianTimeModel-Core-MaximilianoTaborda.3.0.0';
				package: 'Chalten-GregorianTimeModel-Tests' with: 'Chalten-GregorianTimeModel-Tests-MaximilianoTaborda.3.0.0';
				package: 'Chalten-JulianTimeModel-Core' with: 'Chalten-JulianTimeModel-Core-MaximilianoTaborda.3.0.0';
				package: 'Chalten-JulianTimeModel-Tests' with: 'Chalten-JulianTimeModel-Tests-MaximilianoTaborda.3.0.0';
				package: 'Chalten-HebrewTimeModel-Core' with: 'Chalten-HebrewTimeModel-Core-MaximilianoTaborda.3.0.0';
				package: 'Chalten-HebrewTimeModel-Tests' with: 'Chalten-HebrewTimeModel-Tests-MaximilianoTaborda.3.0.0';
				package: 'Chalten-IslamicTimeModel-Core' with: 'Chalten-IslamicTimeModel-Core-MaximilianoTaborda.3.0.0';
				package: 'Chalten-IslamicTimeModel-Tests' with: 'Chalten-IslamicTimeModel-Tests-MaximilianoTaborda.3.0.0';
				package: 'Chalten-TimeLineFilterModel-Core' with: 'Chalten-TimeLineFilterModel-Core-MaximilianoTaborda.3.0.0';
				package: 'Chalten-TimeLineFilterModel-Tests' with: 'Chalten-TimeLineFilterModel-Tests-MaximilianoTaborda.3.0.0';
				package: 'Chalten-TimeZoneModel-Core' with: 'Chalten-TimeZoneModel-Core-MaximilianoTaborda.3.0.0';
				package: 'Chalten-TimeZoneModel-Tests' with: 'Chalten-TimeZoneModel-Tests-MaximilianoTaborda.3.0.0' ]! !
